//+------------------------------------------------------------------+
//|                       _Waddah Attar Daily Fibo Series Proj       |
//|                                   Copyright  2007, Waddah Attar |
//|                             Waddah Attar waddahattar@hotmail.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, Waddah Attar waddahattar@hotmail.com"
#property link      "waddahattar@hotmail.com"
//----
#property indicator_chart_window
#property indicator_buffers 8
#property indicator_color1 LightPink 
#property indicator_color2 LightPink
#property indicator_color3 LightPink 
#property indicator_color4 LightPink
#property indicator_color5 PowderBlue
#property indicator_color6 PowderBlue
#property indicator_color7 PowderBlue
#property indicator_color8 PowderBlue

extern bool ShowPercent=true;
/*
STYLE_SOLID 0 The pen is solid. 
STYLE_DASH 1 The pen is dashed. 
STYLE_DOT 2 The pen is dotted. 
STYLE_DASHDOT 3 The pen has alternating dashes and dots. 
STYLE_DASHDOTDOT 4 The pen has alternating dashes and double dots. 
*/
extern int myStyle  = 2 ;

extern double myFib1  = 0.34 ;
extern double myFib2  = 0.55 ;
extern double myFib3  = 0.89 ;
extern double myFib4  = 1.44 ;

//---- buffers
double P1Buffer[];
double P2Buffer[];
double P3Buffer[];
double P4Buffer[];
double P5Buffer[];
double P6Buffer[];
double P7Buffer[];
double P8Buffer[];

//----
int myPeriod = PERIOD_D1;


//----
double Q,H,L,F,C;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   SetIndexBuffer(0, P1Buffer);
   SetIndexBuffer(1, P2Buffer);
   SetIndexBuffer(2, P3Buffer);
   SetIndexBuffer(3, P4Buffer);
   SetIndexBuffer(4, P5Buffer);
   SetIndexBuffer(5, P6Buffer);
   SetIndexBuffer(6, P7Buffer);
   SetIndexBuffer(7, P8Buffer);   
   
//----
   SetIndexStyle(0, DRAW_LINE, myStyle , 1);
   SetIndexStyle(1, DRAW_LINE, myStyle, 1);  //  STYLE_SOLID
   SetIndexStyle(2, DRAW_LINE, myStyle, 1);
   SetIndexStyle(3, DRAW_LINE, myStyle, 1);
   SetIndexStyle(4, DRAW_LINE, myStyle, 1);
   SetIndexStyle(5, DRAW_LINE, myStyle, 1);
   SetIndexStyle(6, DRAW_LINE, myStyle, 1);
   SetIndexStyle(7, DRAW_LINE, myStyle, 1);   
   
   
//----
   Comment("Waddah Attar Daily Fibo Proj");
   return(0);
  }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
   ObjectDelete("DayFSP1");
   ObjectDelete("DayFSP2");
   ObjectDelete("DayFSP3");
   ObjectDelete("DayFSP4");
   ObjectDelete("DayFSP5");
   ObjectDelete("DayFSP6");
   ObjectDelete("DayFSP7");
   ObjectDelete("DayFSP8");  
   ObjectDelete("txtDayFSP1");
   ObjectDelete("txtDayFSP2");
   ObjectDelete("txtDayFSP3");
   ObjectDelete("txtDayFSP4");
   ObjectDelete("txtDayFSP5");
   ObjectDelete("txtDayFSP6");
   ObjectDelete("txtDayFSP7");
   ObjectDelete("txtDayFSP8");   
   
   ObjectDelete("DPercent");
   ObjectDelete("DPrice");
   Comment("");
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int i, dayi, counted_bars = IndicatorCounted();
//---- check for possible errors
   if(counted_bars < 0) 
       return(-1);
//---- last counted bar will be recounted
   if(counted_bars > 0) 
       counted_bars--;  
   int limit = Bars - counted_bars;
//----   
   for(i = limit - 1; i >= 0; i--)
     {
       dayi = iBarShift(Symbol(), myPeriod, Time[i], false);
       H=iHigh(Symbol(), myPeriod,dayi + 1);
       L=iLow(Symbol(), myPeriod,dayi + 1);
       Q = (H-L);
       C = iClose(Symbol(), myPeriod,dayi + 1); 
       
       //----
       
       P1Buffer[i] = C+myFib1;
       SetPrice("DayFSP1", Time[i], P1Buffer[i], indicator_color1);
       SetText("txtDayFSP1", "Proj 1                   ", Time[i], P1Buffer[i], indicator_color1);
       //----
       P2Buffer[i] = C+myFib2;
       SetPrice("DayFSP2", Time[i], P2Buffer[i], indicator_color2);
       SetText("txtDayFSP2", "Proj 2                   ",  Time[i], P2Buffer[i], indicator_color2);
       //----
       P3Buffer[i] = C+myFib3;
       SetPrice("DayFSP3", Time[i], P3Buffer[i], indicator_color3);
       SetText("txtDayFSP3", "Proj 3                   ",  Time[i],P3Buffer[i], indicator_color3);
       //----
       P4Buffer[i] = C+myFib4;
       SetPrice("DayFSP4", Time[i], P4Buffer[i], indicator_color4);
       SetText("txtDayFSP4", "Proj 4                   ",  Time[i], P4Buffer[i], indicator_color4);
       //----           
       P5Buffer[i] = C-myFib1;
       SetPrice("DayFSP5", Time[i], P5Buffer[i], indicator_color5);
       SetText("txtDayFSP5", "Proj 5                   ", Time[i], P5Buffer[i], indicator_color5);
       //----
       P6Buffer[i] = C-myFib2;
       SetPrice("DayFSP6", Time[i], P6Buffer[i], indicator_color6);
       SetText("txtDayFSP6", "Proj 6                   ",  Time[i], P6Buffer[i], indicator_color6);
       //----
       P7Buffer[i] = C-myFib3;
       SetPrice("DayFSP7", Time[i], P7Buffer[i], indicator_color7);
       SetText("txtDayFSP7", "Proj 7                   ",  Time[i],P7Buffer[i], indicator_color7);
       //----
       P8Buffer[i] = C-myFib4;
       SetPrice("DayFSP8", Time[i], P8Buffer[i], indicator_color8);
       SetText("txtDayFSP8", "Proj 8                   ",  Time[i], P8Buffer[i], indicator_color8);
       //----
      
    }
    
    F=(Bid-L)/Q*100;
    
    if (ShowPercent==true)
    {
//    SetLabel("Prev Close","Price ="+DoubleToStr(C,Digits),1,30,"Simplified Arabic Fixed",20,0,indicator_color1);
//    SetLabel("DPercent","D Fibo="+DoubleToStr(F,2)+"%",1,92,"Simplified Arabic Fixed",20,0,indicator_color1);
    }
    else
    {
      ObjectDelete("DPercent");
      ObjectDelete("DPrice");
    }
//----
   return(0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void SetPrice(string name, datetime Tm, double Prc, color clr)
  {
   if(ObjectFind(name) == -1)
     {
       ObjectCreate(name, OBJ_ARROW, 0, Tm, Prc);
       ObjectSet(name, OBJPROP_COLOR, clr);
       ObjectSet(name, OBJPROP_WIDTH, 1);
       ObjectSet(name, OBJPROP_ARROWCODE, SYMBOL_RIGHTPRICE);
     }
   else
     {
       ObjectSet(name, OBJPROP_TIME1, Tm);
       ObjectSet(name, OBJPROP_PRICE1, Prc);
       ObjectSet(name, OBJPROP_COLOR, clr);
       ObjectSet(name, OBJPROP_WIDTH, 1);
       ObjectSet(name, OBJPROP_ARROWCODE, SYMBOL_RIGHTPRICE);
     } 
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void SetText(string name, string txt, datetime Tm, double Prc, color clr)
  {
   if(ObjectFind(name) == -1)
     {
       ObjectCreate(name, OBJ_TEXT, 0, Tm, Prc);
       ObjectSetText(name, txt, 10, "Times New Roman", clr);
       ObjectSet(name, OBJPROP_CORNER, 2);
     }
   else
     {
       ObjectSet(name, OBJPROP_TIME1, Tm);
       ObjectSet(name, OBJPROP_PRICE1, Prc);
       ObjectSetText(name, txt, 10, "Times New Roman", clr);
       ObjectSet(name, OBJPROP_CORNER, 2);
     } 
  }
  
void SetLabel(string name,string txt,int x,int y,string font,int size,int angle,color clr)
  {
   int idx=0;
   if(ObjectFind(name) == -1)
     {
       ObjectCreate(name, OBJ_LABEL, idx, 0, 0);
       ObjectSetText(name, txt, size, font, clr);
       ObjectSet(name, OBJPROP_XDISTANCE, x);
       ObjectSet(name, OBJPROP_YDISTANCE, y);
       ObjectSet(name, OBJPROP_CORNER, 2);
       ObjectSet(name, OBJPROP_ANGLE, angle);
     }
   else
     {
       ObjectSet(name, OBJPROP_XDISTANCE, x);
       ObjectSet(name, OBJPROP_YDISTANCE, y);
       ObjectSetText(name, txt, size, font, clr);
       ObjectSet(name, OBJPROP_CORNER, 2);
       ObjectSet(name, OBJPROP_ANGLE, angle);
     } 
  }

//+------------------------------------------------------------------+